﻿using System;
using System.Reactive.Linq;
using SilverlightApplication1.BingTranslatorService;
using System.Threading;

namespace SilverlightApplication1.Observables
{
    public static class BingTranslatorObservable
    {
        /// <summary>
        /// The AppId identifies your application at the Bing online service.
        /// Before running the application, you have to get your free AppId
        /// here: http://www.bing.com/developers/createapp.aspx
        /// </summary>
        const string AppID = "1848A7A37C632E32B67492E22DA29125992A298C";

        public static IObservable<Object[]> TranslateAsync(this string text,
            string sourceLanguage, string targetLanguage)
        {
            var svc = new BingTranslatorService.LanguageServiceClient();
            var values = new ServiceParams { AppID = AppID, sourceLanguage = sourceLanguage, targetLanguage = targetLanguage, Text = text };

            var obs = Observable.FromAsyncPattern<ServiceParams, object[]>(svc.BeginTranslate, svc.OnEndTranslate)(values)
                .ObserveOn(SynchronizationContext.Current);
            return obs;
        }
    }
}
